Last Comment Bug 533249 - Crash [@ nsImapMailFolder::NotifySearchHit(nsIMsgMailNewsUrl*, char const*) ]
: Crash [@ nsImapMailFolder::NotifySearchHit(nsIMsgMailNewsUrl*, char const*) ]
Status: RESOLVED FIXED
[needs verification post 3.0.1][poten...
: crash, fixed-seamonkey2.0.3, topcrash
Product: MailNews Core
Classification: Components
Component: Networking: IMAP (show other bugs)
: 1.9.1 Branch
: All All
: -- critical (vote)
: Thunderbird 3.1a1
Assigned To: David :Bienvenu
:
:
Mentors:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2009-12-07 01:31 PST by Ludovic Hirlimann [:Usul]
Modified: 2011-06-13 10:01 PDT (History)
6 users (show)
See Also:
Crash Signature:
QA Whiteboard:
Iteration: ---
Points: ---
.1+
.1-fixed


Attachments
proposed fix - checked in. (488 bytes, patch)
2009-12-11 17:02 PST, David :Bienvenu
neil: review+
neil: superreview+
standard8: approval‑thunderbird3.0.1+
Details | Diff | Splinter Review

Description Ludovic Hirlimann [:Usul] 2009-12-07 01:31:52 PST
0  	thunderbird-bin  	nsImapMailFolder::NotifySearchHit  	 mailnews/imap/src/nsImapMailFolder.cpp:5518
1 	libxpcom_core.dylib 	NS_InvokeByIndex_P 	xpcom/reflect/xptcall/src/md/unix/xptcinvoke_unixish_x86.cpp:179
2 	libxpcom_core.dylib 	nsProxyObjectCallInfo::Run 	xpcom/proxy/src/nsProxyEvent.cpp:181
3 	libxpcom_core.dylib 	nsThread::ProcessNextEvent 	xpcom/threads/nsThread.cpp:521
4 	libxpcom_core.dylib 	NS_ProcessPendingEvents_P 	nsThreadUtils.cpp:189
5 	thunderbird-bin 	nsBaseAppShell::NativeEventCallback 	widget/src/xpwidgets/nsBaseAppShell.cpp:121
6 	thunderbird-bin 	nsAppShell::ProcessGeckoEvents 	widget/src/cocoa/nsAppShell.mm:406
7 	CoreFoundation 	CFRunLoopRunSpecific 	
8 	CoreFoundation 	CFRunLoopRunInMode 	
9 	HIToolbox 	RunCurrentEventLoopInMode 	
10 	HIToolbox 	ReceiveNextEventCommon 	
11 	HIToolbox 	BlockUntilNextEventMatchingListInMode 	
12 	AppKit 	_DPSNextEvent 	
13 	AppKit 	-[NSApplication nextEventMatchingMask:untilDate:inMode:dequeue:] 	
14 	AppKit 	-[NSApplication run] 	
15 	thunderbird-bin 	nsAppShell::Run 	widget/src/cocoa/nsAppShell.mm:759
16 	thunderbird-bin 	nsAppStartup::Run 	toolkit/components/startup/src/nsAppStartup.cpp:193
17 	thunderbird-bin 	XRE_main 	toolkit/xre/nsAppRunner.cpp:3321
18 	thunderbird-bin 	main 	mail/app/nsMailApp.cpp:103
19 	thunderbird-bin 	thunderbird-bin@0x1a31 	
20 	thunderbird-bin 	thunderbird-bin@0x1958 	
21 		@0x1


0  	thunderbird.exe  	nsImapMailFolder::NotifySearchHit  	 mailnews/imap/src/nsImapMailFolder.cpp:5518
1 	xpcom_core.dll 	NS_InvokeByIndex_P 	xpcom/reflect/xptcall/src/md/win32/xptcinvoke.cpp:101
2 	xpcom_core.dll 	nsEventQueue::GetEvent 	xpcom/threads/nsEventQueue.cpp:100
3 	xpcom_core.dll 	nsProxyObjectCallInfo::Run 	xpcom/proxy/src/nsProxyEvent.cpp:181
4 	xpcom_core.dll 	nsThread::ProcessNextEvent 	xpcom/threads/nsThread.cpp:521
5 	xpcom_core.dll 	NS_ProcessNextEvent_P 	objdir-tb/mozilla/xpcom/build/nsThreadUtils.cpp:236
6 	thunderbird.exe 	nsBaseAppShell::Run 	widget/src/xpwidgets/nsBaseAppShell.cpp:170
7 	thunderbird.exe 	nsAppStartup::Run 	toolkit/components/startup/src/nsAppStartup.cpp:193
8 	thunderbird.exe 	XRE_main 	toolkit/xre/nsAppRunner.cpp:3321
9 	thunderbird.exe 	NS_internal_main 	mail/app/nsMailApp.cpp:103
10 	thunderbird.exe 	wmain 	toolkit/xre/nsWindowsWMain.cpp:110
11 	thunderbird.exe 	__tmainCRTStartup 	objdir-tb/mozilla/memory/jemalloc/src/crtexe.c:591
12 	kernel32.dll 	BaseProcessStart 	

Seems to involve smart folders.
Comment 1 Wayne Mery (:wsmwk, NI for questions) 2009-12-07 04:40:41 PST
a minority appear to be startup crashes
bp-0e2c50c5-bf8c-4d65-89a1-f9c672091206
0	thunderbird.exe	nsImapMailFolder::NotifySearchHit	 mailnews/imap/src/nsImapMailFolder.cpp:5518
1	xpcom_core.dll	NS_InvokeByIndex_P	xpcom/reflect/xptcall/src/md/win32/xptcinvoke.cpp:101
2	xpcom_core.dll	nsEventQueue::GetEvent	xpcom/threads/nsEventQueue.cpp:100
3	xpcom_core.dll	nsProxyObjectCallInfo::Run	xpcom/proxy/src/nsProxyEvent.cpp:181
4	xpcom_core.dll	nsThread::ProcessNextEvent	xpcom/threads/nsThread.cpp:521
5	xpcom_core.dll	NS_ProcessNextEvent_P	objdir-tb/mozilla/xpcom/build/nsThreadUtils.cpp:236
6	thunderbird.exe	nsBaseAppShell::Run	widget/src/xpwidgets/nsBaseAppShell.cpp:170
7	thunderbird.exe	nsAppStartup::Run	toolkit/components/startup/src/nsAppStartup.cpp:193
8	thunderbird.exe	XRE_main	toolkit/xre/nsAppRunner.cpp:3321
Comment 2 Wayne Mery (:wsmwk, NI for questions) 2009-12-07 04:44:00 PST
#2 crash for v3.0
Comment 3 David :Bienvenu 2009-12-07 06:52:25 PST
Smart folders should not run their searches online. It's possible that earlier nightly versions of TB created smart folders that would run their search online, or that it's random...I'd have to check with a new profile.
Comment 4 Wayne Mery (:wsmwk, NI for questions) 2009-12-07 17:37:06 PST
not a new crash. but pretty rare even in 3.0b4 where it ranks #136. then with 3.0 build 2009113000 it takes off like a rocket, so worth speculating whether there is also a regression.

bp-b82957e6-78ca-4bca-a14b-0c2a32090528  for 3.0b2 is typical
0	thunderbird-bin	nsImapMailFolder::NotifySearchHit	 nsImapMailFolder.cpp:5056
1	libxpcom_core.dylib	NS_InvokeByIndex_P	xpcom/reflect/xptcall/src/md/unix/xptcinvoke_unixish_x86.cpp:179
2	libxpcom_core.dylib	nsProxyObjectCallInfo::Run	xpcom/proxy/src/nsProxyEvent.cpp:181 

and some are eudora eg bp-02b2e82a-fdac-4cf7-b6ae-aa2ef2090922 3.0b2
0	eudora.exe	nsImapMailFolder::NotifySearchHit	 nsImapMailFolder.cpp:5132
1	xpcom_core.dll	NS_InvokeByIndex_P	xpcom/reflect/xptcall/src/md/win32/xptcinvoke.cpp:101
2	xpcom_core.dll	nsEventQueue::GetEvent	xpcom/threads/nsEventQueue.cpp:100
3	xpcom_core.dll	nsProxyObjectCallInfo::Run	xpcom/proxy/src/nsProxyEvent.cpp:181
Comment 5 David :Bienvenu 2009-12-07 19:53:39 PST
My only thought is that the code that tries to determine if searches should run online or offline might somehow getting confused. But that code went in long before 11/30.
Comment 6 Wayne Mery (:wsmwk, NI for questions) 2009-12-08 06:48:20 PST
now #1 crash, on 3 day view

bp-61591732-1f54-4a29-95a8-d9b4e2091207
resetting the message filter with the "x"-button in the search field Thunderbird 3r2 crashes
Comment 7 David :Bienvenu 2009-12-11 17:02:43 PST
Created attachment 417208 [details] [diff] [review]
proposed fix - checked in.

null check aUrl - it's the only reason I can see that we would crash here.

There's a possibly related issue where we're doing quick searches online in smart mailboxes online sometimes. I'm working on a fix for that.
Comment 8 David :Bienvenu 2009-12-12 14:23:59 PST
I've landed the null check fix, though I'm not sure it's really going to make this go away...leaving open for now, as well as for the online search that should be done offline.
Comment 9 Mark Banner (:standard8, limited time in Dec) 2009-12-22 04:22:11 PST
David, what do you want to do for this wrt 3.0.1?
Comment 10 David :Bienvenu 2009-12-22 06:52:01 PST
Comment on attachment 417208 [details] [diff] [review]
proposed fix - checked in.

We should probably take this for 3.01, just in case. But I want to fix the search to happen offline for 3.01, since it will be much faster, and not hit the crashing code.
Comment 11 Mark Banner (:standard8, limited time in Dec) 2010-01-04 04:33:00 PST
Comment on attachment 417208 [details] [diff] [review]
proposed fix - checked in.

a=Standard8

Please move the remaining follow-ups into separate bugs, so that we can just track the crash in this bug (which makes tracking 3.0.x easier). Thanks.
Comment 12 David :Bienvenu 2010-01-04 12:52:59 PST
ok, marking blocking and fixed for 3.01.
Comment 13 Wayne Mery (:wsmwk, NI for questions) 2010-01-10 15:46:29 PST
can't verify this is gone - we have no testcase, patch only just landed, and
crash frequency is insufficient to say it's gone from trunk or 3.0.1pre (crash
rate there is 0).  So verification can't happen until several days after 3.0.1 ships.

Note You need to log in before you can comment on or make changes to this bug.